/* AMX Mod script.
*
* (c) Copyright 2002, OLO
* This file is provided as is (no warranties).
*
*/

/*
*  Admin command:
*  amx_statscfg - displays menu with configuration
*
*/

#include <amxmod>
#include <amxmisc>

#define MAX_MENU_DATA 64

new menu_data[MAX_MENU_DATA][32]
new menu_data_ids[MAX_MENU_DATA][2]
new menu_data_num
new menu_user_pos[33]
new bool:modified

new filetosave[] = "addons/amx/stats.ini"

public plugin_precache(){
	register_clcmd("amx_statscfg","show_statsmenu",ADMIN_CFG,"- displays stats configuration")
	register_srvcmd("amx_addoption","set_statsmenu")
	for(new a = 5; a < 10; ++a)	remove_user_flags(0,-1,a)
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Stats Settings","0.9.3","default")
	register_menucmd(register_menuid("\yStats Settings"),1023,"action_settingsmenu")
	load_settings(filetosave)
	return PLUGIN_CONTINUE
}

public set_statsmenu(){
	if (menu_data_num>=MAX_MENU_DATA || read_argc()<4) 
		return PLUGIN_HANDLED
	new cmd[32], channel[4], flag[4]
	read_argv(1,cmd,31)
	read_argv(2,channel,3)	
	read_argv(3,flag,3)
	copy(menu_data[menu_data_num],31,cmd)
	menu_data_ids[menu_data_num][0] = strtonum(channel)
	menu_data_ids[menu_data_num][1] = strtonum(flag)
	menu_data_num++
	return PLUGIN_HANDLED
}

public show_statsmenu(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	show_settingsmenu(id,menu_user_pos[id] = 0)
	return PLUGIN_HANDLED
}

show_settingsmenu(id,pos){
	if (pos < 0) return
	new menu_body[512], start = pos * 7
	if (start >= menu_data_num) start = pos = menu_user_pos[id] = 0
	new len = format(menu_body,511,"\yStats Settings\R%d/%d^n\w^n",
		pos + 1,((menu_data_num/7)+((menu_data_num%7)?1:0)))
	new end = start + 7, keys = (1<<9)|(1<<7)
	if (end > menu_data_num) end = menu_data_num
	pos = 0
	for(new a = start; a < end; ++a){
		keys |= (1<<pos)
		len += format(menu_body[len],511-len,"%d. %s\y\R%s^n\w",++pos,
			menu_data[a], (get_user_flags(0,menu_data_ids[a][0]) & (1<<menu_data_ids[a][1]) ) ? "ON" : "OFF")
	}
	len += format(menu_body[len],511-len,"^n8. Save settings \y\R%s^n\w",modified ? "*" : "")
	if (end != menu_data_num){
		len += format(menu_body[len],511-len,"^n9. More...^n0. Back")
		keys |= (1<<8)
	}
	else {
		len += format(menu_body[len],511-len,"^n0. Back")
	}
	show_menu(id,keys,menu_body)
}

public action_settingsmenu(id,key){
	switch(key){
	case 7:{
			if (save_settings(filetosave)){
				modified = false
				client_print(id,print_chat,"* Configuration saved successfully")
			}
			else
				client_print(id,print_chat,"* Configuration saving failed!!!")
			show_settingsmenu(id,menu_user_pos[id])
		}
	case 8: show_settingsmenu(id,++menu_user_pos[id])
	case 9:	show_settingsmenu(id,--menu_user_pos[id])
	default:{
			new option = menu_user_pos[id] * 7 + key
			new myflag =  (1 << (menu_data_ids[option][1]))
			new mychannel = menu_data_ids[option][0]
			modified = true
			if ( get_user_flags(0,mychannel ) & myflag )
				remove_user_flags(0,myflag,mychannel)
			else
				set_user_flags(0,myflag,mychannel)
			show_settingsmenu(id,menu_user_pos[id])
		}
	}
	return PLUGIN_HANDLED
}

save_settings(filename[]){
	if (file_exists(filename))
		delete_file(filename)
	new text[256]
	if (!write_file(filename,";Generated by Stats Settings Plugin. Do not modify!^n;Channel  Flag  Description"))
		return 0
	for(new a = 0; a < menu_data_num; ++a){
		if ((get_user_flags(0,menu_data_ids[a][0]) & (1<<menu_data_ids[a][1]) )){
			format(text,255,"%d %d ;%s",menu_data_ids[a][0],menu_data_ids[a][1],menu_data[a])
			write_file(filename,text)
		}
	}
	return 1
}

load_settings(filename[]){
	if (!file_exists(filename)) return 0
	new text[256], channel[4], flag[4], len, pos = 0
	while (read_file(filename,pos++,text,255,len)){
		if ( text[0] == ';' ) continue // line is a comment
		parse(text,channel,3,flag,3)
		set_user_flags(0,(1<<strtonum(flag)),strtonum(channel))
	}
	return 1
}